#!/usr/bin/python

#TODO:
# - filter '\0' chars from ELM (ELM327DSH.pdf, page 8, note on bottum of page)

import serial
import thread
import time
import sys
import codes
import decode
import obdtrace
import communicate
trace=obdtrace.obdtrace("tour.log")

#ec=communicate.elmComm("|./obdtest.py")
ec=communicate.elmComm("/dev/ttyUSB0")

def logAll():
    pid=0x00
    mode=1
    #for mode in sorted decode.pids.keys():
    while True:
        supported=ec.askOBD(1,pid)[1:]
        try:
            trace.log("[%02x,%02x] Supported: %s"%(1,pid,decode.decodeSuppordedPID(supported,pid)))
        except:
            pass
        ar=[1]
        for i in range(0x20):
            ar.append((ord(supported[i/8])<<(i%8))&0x80!=0)
        print ar
        for ipid in range(pid+1, pid+0x21):
            #print "logAll:",ipid, ar[ipid]
            if ar[ipid-pid]:
                try:
                    (nbyte,name,func,args)=codes.pids[mode][ipid]
                    if func!=None:
                        r=ec.askOBD(mode, ipid)[1:]
                        s=func(r,ipid,*args)
                        trace.log("[%02x,%02x] %s: %s"%(mode,ipid,name,s))
                        if mode==1 and ipid ==1:
                            nError=ord(r[0])&0x7f
                            r=ec.askOBD(3,0)
                            trace.log("[03] Error codes: "+decode.decodeErrorCodes(r,0))

                except:
                    r=ec.askOBD(mode, ipid)[1:]
        if ar[-1]:
            pid+=0x20
            if pid>0x300:
                break
        else:
            break
    #ec.askOBD(9,0)
    #ec.askOBD(9,1)
    #ec.askOBD(9,2)
    #ec.askOBD(1,0x60)
    #ec.askOBD(1,0x80)
    #ec.askOBD(1,0xA0)
    #ec.askOBD(1,0xC0)

#rpm
#brandstofverbruik
#speed
#temp
#
#temp
#throttle position
ec.send("ATZ") #reset all
ec.send("ATL0") #switch off line feeds

ec.send("ATS1") #S0: switch off space printign (every third byte)
ec.send("ATE0")
ec.send("ATDP") #describe current protocol (CAN, ISO, ...)
ec.send("ATDPN") #describe protocol by number
if False:
    ec.send("ATH1")  #H1: headers on. 01 05 01->48 6B 10 41 05 61 6A
    ec.askOBD(1,1)
    ec.askOBD(1,0x5)
    time.sleep(0.3)
    sys.exit()
#ec.send("03")
#sys.exit()
#ec.send("ATMA") #monitor all
#time.sleep(100000)
ec.askOBD(1,1)
logAll()
